/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (C) Yeico S. A. de C. V.
 * xlsLib -- A multiplatform, C++ library for dynamic generation of Excel (TM) 
 * files.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  
 * $Source: /cvsroot/xlslib/xlslib/src/xlslib/record.cpp,v $
 * $Revision: 1.1.1.1 $
 * $Author: darioglz $
 * $Date: 2004/08/27 16:31:46 $
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * File description:
 *
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#include "record.h"

using namespace std;
using namespace xlslib_core;

/* 
******************************
CRecord class implementation
******************************
*/


CRecord::CRecord()
   :m_Num(RECTYPE_NULL)

{

   // Initialize (and create) the space for record type
   // and record length
   const unsigned8_t array[] = {0,0,0,0} ; 
   AddDataArray(array, 4);
  


}

CRecord::~CRecord()
{
}

/* 
******************************
******************************
*/
void CRecord::SetRecordType(unsigned16_t rtype)
{
   SetValueAt((signed16_t)rtype, 0);

}


/* 
******************************
******************************
*/

unsigned16_t CRecord::GetRecordType()
{
   unsigned16_t value;
   GetValue16From((signed16_t*)&value, 0);

   return value;
}

/* 
******************************
******************************
*/
void CRecord::SetRecordLength(unsigned16_t rlength)
{
   SetValueAt((signed16_t)rlength, 2);

}


/* 
******************************
******************************
*/

unsigned16_t CRecord::GetRecordLength()
{
   unsigned16_t value;
   GetValue16From((signed16_t*)&value, 2);

   return value;
}


/* 
******************************
******************************
*/

unsigned8_t* CRecord::GetRecordDataBuffer()
{
   return GetBuffer() + 4;

}


/* 
******************************
******************************
*/
unsigned32_t CRecord::GetRecordDataSize()
{
   return GetDataSize() - 4;
}

/* 
******************************
******************************
*/

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * $Log: record.cpp,v $
 * Revision 1.1.1.1  2004/08/27 16:31:46  darioglz
 * Initial Import.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

